VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Click and drag twice to define the line segments"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_LastX As Single
Private m_LastY As Single

' Display the intersection information.
Private Sub IntersectLines()
Dim X As Single
Dim Y As Single
Dim X1 As Single
Dim Y1 As Single
Dim X2 As Single
Dim Y2 As Single

    ' See where the segments intersect.
    FindLineIntersection _
        m_Points(1).X, m_Points(1).Y, _
        m_Points(2).X, m_Points(2).Y, _
        m_Points(3).X, m_Points(3).Y, _
        m_Points(4).X, m_Points(4).Y, _
        X, Y, X1, Y1, X2, Y2
    If X >= 1E+38 Then
        ' The lines are parallel.
        CurrentX = (ScaleWidth - TextWidth("Parallel")) / 2
        CurrentY = (ScaleHeight - TextHeight("Parallel")) / 2
        Print "Parallel"
    Else
        ' Draw the various points.
        If X1 <> X2 Or Y1 <> Y2 Then
            DrawStyle = vbDot
            Line (X, Y)-(X1, Y1), vbBlack
            Line (X, Y)-(X2, Y2), vbBlack
            DrawStyle = vbSolid
        End If
        Circle (X, Y), 2, vbRed
    End If
End Sub
Private Sub Form_Load()
    AutoRedraw = True
    ScaleMode = vbPixels
    ForeColor = vbRed
    Font.Name = "Times New Roman"
    Font.Bold = True
    Font.Size = 40
End Sub
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Get the next point.
    m_LastPoint = m_LastPoint + 1

    ' See if we need to start a new series of lines.
    If m_LastPoint = 5 Then
        m_LastPoint = 1
        Cls
    End If

    ' Save the point.
    With m_Points(m_LastPoint)
        .X = X
        .Y = Y
        m_LastX = X
        m_LastY = Y
        Circle (X, Y), 2, vbBlack
    End With

    ' Start rubberband drawing.
    DrawMode = vbInvert
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Only draw a line if we are working on
    ' the second or fourth point.
    If m_LastPoint <> 1 And m_LastPoint <> 3 Then Exit Sub

    With m_Points(m_LastPoint)
        ' Erase the last line.
        Line (.X, .Y)-(m_LastX, m_LastY)

        ' Save the new point.
        m_LastX = X
        m_LastY = Y

        ' Draw the new line.
        Line (.X, .Y)-(m_LastX, m_LastY)
    End With
End Sub


Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Save the new point.
    m_LastPoint = m_LastPoint + 1
    With m_Points(m_LastPoint)
        .X = m_LastX
        .Y = m_LastY
        Circle (X, Y), 2, vbBlack
    End With

    ' Draw the new line.
    With m_Points(m_LastPoint - 1)
        DrawMode = vbCopyPen
        Line (.X, .Y)-(m_LastX, m_LastY), vbBlack
    End With

    ' See if this is the last point.
    If m_LastPoint = 4 Then
        IntersectLines
    End If
End Sub
